import java.sql.*; 
public class SavepointEx { 
	static{ 
		try{ 
			Class.forName("oracle.jdbc.driver.OracleDriver"); 
		}catch(ClassNotFoundException cnfe){ 
			cnfe.printStackTrace(); 
		} 
	}
	public static void main(String args[]) { 
		Connection con = null; 
		PreparedStatement selectPs = null; 
		PreparedStatement updatePs = null; 
		ResultSet rs = null; 
		String sql = null; 
		try{ 
			con = DriverManager.getConnection( 
					"jdbc:oracle:thin:@localhost:1521:xe", 
					"system", 
					"1111"); 
			con.setAutoCommit(false); 
			String query = "SELECT id, total FROM savepoint "+ 
					"WHERE total > ?"; 
			String update = "UPDATE savepoint SET total = ? "+ 
					"WHERE id = ?"; 

			selectPs = con.prepareStatement(query); 
			updatePs = con.prepareStatement(update); 

			selectPs.setInt(1, 100); 
			rs = selectPs.executeQuery(); 

			Savepoint save1 = con.setSavepoint(); 

			while (rs.next()) { 
				String id = rs.getString("id"); 
				int oldTotal = rs.getInt("total"); 
				int newPrice = (oldTotal * 2); 
				updatePs.setInt(1, newPrice); 
				updatePs.setString(2, id); 
				updatePs.executeUpdate(); 
				System.out.println("New Total of " + oldTotal+ 
						" is " + newPrice); 
				if (newPrice >= 5000) {
					con.rollback(save1); 
				} 
			} 

			System.out.println(); 
			selectPs = con.prepareStatement(query); 
			updatePs = con.prepareStatement(update); 
			selectPs.setInt(1, 100); 

			rs = selectPs.executeQuery(); 

			Savepoint save2 = con.setSavepoint(); 

			while (rs.next()) { 
				String id = rs.getString("id"); 
				int oldTotal = rs.getInt("total"); 
				int newPrice = (oldTotal * 2); 
				updatePs.setInt(1, newPrice); 
				updatePs.setString(2, id); 
				updatePs.executeUpdate(); 
				System.out.println("New Total of " + oldTotal+ 
						" is " +newPrice); 
				if (newPrice >= 5000) { 
					con.rollback(save2); 
				} 
			} 
			System.out.println(); 
			con.commit(); 
			Statement stmt = con.createStatement(); 
			rs = stmt.executeQuery("SELECT id, " + 
					"total FROM savepoint"); 

			System.out.println(); 
			while (rs.next()) { 
				String id = rs.getString("id");
				int price = rs.getInt("total"); 
				System.out.println("id : "+ id 
						+" , total : " + price); 
			} 
		} catch (Exception e) { 
			e.printStackTrace(); 
		}finally{ 
			try { 
				if(rs != null)rs.close(); 
				if(selectPs != null)selectPs.close(); 
				if(updatePs != null)updatePs.close(); 
				if(con != null)con.close(); 
			}catch(SQLException e){ 
			} 
		} 
	} 
} 
